require "import"
import "java.util.Locale"

local form, to, text, ltr = ...

-- Fungsi untuk URL encoding
function urlencode(str)
  if (str) then
    str = string.gsub(str, "\n", "\r\n")
    str = string.gsub(str, "([^%w %-%_%.%~])", -- Karakter yang perlu di-encode
      function (c) return string.format("%%%02X", string.byte(c)) end)
    str = string.gsub(str, " ", "+") -- Ganti spasi dengan +
  end
  return str
end

-- Fungsi untuk URL decoding
function urldecode(str)
  str = string.gsub(str, "%%(%x%x)", function(hex)
    return string.char(tonumber(hex, 16))
  end)
  str = string.gsub(str, "+", " ") -- Ganti '+' kembali menjadi spasi
  return str
end

-- Fungsi untuk mengonversi entitas HTML menjadi karakter asli
function html_entity_decode(str)
  local entities = {
    ["&#39;"] = "'",
    ["&quot;"] = '"',
    ["&amp;"] = "&",
    ["&lt;"] = "<",
    ["&gt;"] = ">",
    ["&dollar;"] = "$",
    -- Tambahkan lebih banyak entitas jika diperlukan
  }
  return (string.gsub(str, "(&%a+%;)", entities))
end

-- Fungsi untuk menghilangkan newline ganda
function normalize_newlines(str)
  return string.gsub(str, "\n\n", "\n")
end

-- Lakukan URL encoding pada parameter 'text'
local encoded_text = urlencode(text)

-- Format URL dengan parameter yang telah di-encode
local url = string.format("https://translate.google.com/m?sl=%s&tl=%s&hl=%s&q=%s", 
    from, to, Locale.getDefault().getCountry(), encoded_text)

-- Melakukan HTTP request
Http.get(url, function(code, response_text)
  -- Ambil hasil terjemahan dari response HTML
  local encoded_result = response_text:match('<div class="result%-container">([^<]+)</div>')
  
  -- Decode URL-encoded characters
  local decoded_result = urldecode(encoded_result)
  
  -- Decode entitas HTML
  local final_result = html_entity_decode(decoded_result)
  
  -- Normalize newline agar tidak menjadi dobel
  final_result = normalize_newlines(final_result)
  
  -- Berikan hasil ke ltr.onTransResult
  ltr.onTransResult(final_result.."\n")
end)